# Responding

Kind of a Struct implementation, but with a nested structure.

## Installation

Add this line to your application's Gemfile:

    gem 'responding'

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install responding

## Usage

Just define your class:

```ruby
  Response = Responding.new(:id, :status => [:ok?, :message])

  response = Response.new(:id => 2, :status => {:ok? => true})

  response.id # => 2
  response.status.ok? # => true
  response.status.message # => nil
```

Every cache-invalidations occur only on creation of the dynamic class, after
this is done, instanciation is safe for your performance.

## Performance

There is a benchmark-script, you can run it like this:

`bundle exec ruby spec/benchmark.rb`

## Contributing

1. Fork it
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create new Pull Request
