require 'benchmark'
require 'ostruct'
require 'responding'

StructClass = Struct.new(:a, :b)
NestedStructClass = Struct.new(:c, :d)

RespondingClass = Responding.new(:a, :b => [:c, :d])

n = 10_000

Benchmark.bmbm do |x|
  x.report("struct") do
    n.times do
      StructClass.new(12, NestedStructClass.new(24, 48))
    end
  end

  x.report("ostruct") do
    n.times do
      OpenStruct.new(:a => 12, :b => OpenStruct.new(:c => 24, :d => 48))
    end
  end

  x.report("responding") do
    n.times do
      RespondingClass.new(:a => 12, :b => {:c => 24, :d => 48})
    end
  end
end
